/*
*	Byte Magazine. March 1987. pp.127.
*
*	remark:		this C routine is a freeware
*
*	ko053@cucs19.cs.cuhk.hk	Internet
*	BiG Programming Club (since 1987), Hong Kong, 6:700/132 FidoNet
*	[852] 654-8751
*-----------------------------------------------------------------------------
*/

#include	"random.h"
#include <float.h>
#include <machine/limits.h>
#ifdef AMIGA
#define MAXFLOAT FLT_MAX
#define MAXINT  INT_MAX
#else
#include <values.h>
#endif
#define	REAL	double
#define	INT	int
/*
*	default seed values
*/
static INT	x = 1;
static INT	y = 10000;
static INT	z = 3000;

/*
*=============================================================================
*	funct:		rndmize
*	dscpt:		generating random number seeds
*	given:		nothing
*	retrn:		nothing
*=============================================================================
*/
INT rndmize()
{
	time_t	timer;

	x = time( &timer ) % 65535;
	y = (x * x) % 65535;
	z = (y * y) % 65535;

return 0;
}

/*
*=============================================================================
*	funct:		rnd
*	dscpt:		return a random number of range 0-1
*	given:		nothing
*	retrn:		the random number
*	cmmnt:		you may use prandomize to change the seeds
*=============================================================================
*/
REAL rnd()
{
	REAL	temp;

	/*
	*	first generator
	*/
	x = 171 * (x % 177) - 2 * (x / 177);
	if (x < 0)
		{
		x += 30269;
		}

	/*
	*	second generator
	*/
	y = 172 * (y % 176) - 35 * (y / 176);
	if (y < 0)
		{
		y += 30307;
		}

	/*
	*	third generator
	*/
	z = 170 * (z % 178) - 63 * (z / 178);
	if (z < 0)
		{
		z += 30323;
		}

	/*
	*	combine to give function value
	*/

		temp = x/30269.0 + y/30307.0 + z/30323.0;


	return (temp - (INT)temp);
}

